#include <iostream>
#include "webcam/Webcam.h"
#include "detection/shape/ContourAnalyzer.h"

int main(int argc, char** argv) {
	Webcam webcam = 0;
	ContourAnalyzer ca;
	bool debug = false;
	int debugFrame = 0;
	int lastKey;
	int state = 0;
	while (true) {
		webcam.update();
		cv::Mat frame = webcam.getFrame();
		ca.setFrame(frame);
		ca.analyze();
		ca.drawShapePositions(frame);


		if (debug) {
			cv::imshow("debug", ca.getDebugFrame(debugFrame));
		}

		cv::imshow("Normal", frame);
		if (lastKey > 0) {
			std::cout << "key pressed: " << lastKey << std::endl;
			if (lastKey == 27) {
				break;
			} else {
				if (lastKey < 52 && lastKey > 48) {
					debugFrame = lastKey - 49;
				}

				if (lastKey == 32) {
					state++;
					if (state >= 3) {
						state = 0;
					}
					printf("state set to: " + state);
				}

				if (lastKey == 100) {
					if (debug) {
						cv::destroyWindow("debug");
						debug = false;
					} else {
						debug = true;
					}
				}
			}
			lastKey = 0;
		}
		lastKey = cv::waitKey(33);
	}

	cv::destroyAllWindows();
	return 0;
}
